# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif
%else
%bcond_with repolib
%endif

%define section free

%define origtag .GA
%define reltag %{origtag}_redhat_2
%define namedversion %{version}%{origtag}-redhat-2
%define meadversion %{version}%{reltag}

%define maven_version 2.2.17.GA-redhat-2

Name:           jboss-common-core
Version:        2.2.17
Release:        10%{?reltag}%{?dist}
Epoch:          1
Summary:        JBoss Common core utility classes
License:        LGPLv2+
URL:            http://www.jboss.org/
Group:          Development/Java

%if %with mead
Source100: org.jboss-jboss-common-core-2.2.17.GA-redhat-2-sources.zip
Source101: org.jboss-jboss-common-core-2.2.17.GA-redhat-2-patches.zip
Source102: jboss-common-core-2.2.17.GA-redhat-2.jar
Source103: jboss-common-core-2.2.17.GA-redhat-2-sources.jar
Source104: jboss-common-core-2.2.17.GA-redhat-2.pom
%endif

# svn export http://anonsvn.jboss.org/repos/common/common-core/tags/2.2.17.GA/ jboss-common-core-2.2.17
# Exported revision 3877.
# tar cjf jboss-common-core-2.2.17.tar.bz2 jboss-common-core-2.2.17
%if %without mead
Source0:        %{name}-%{version}.tar.bz2
Patch0:		%{name}-vman-pom.patch
%endif
Obsoletes:      jboss-common < %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
#Optional:       jakarta-commons-httpclient
#Optional:       jakarta-slide-webdavclient
Requires:       jboss-logging
%if %without mead
BuildRequires:  jpackage-utils
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-slide-webdavclient
BuildRequires:  jboss-logging
BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management
BuildRequires:  junit
BuildRequires:  jboss-deploy-maven-plugin
BuildRequires:  maven-scm
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-default-skin
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  maven-shared-jar
# FIXME OPENJDK: Temporary workaround
#BuildRequires: liberation-fonts
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Common core utility classes.

%if %without mead
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

# FIXME If manual is desired for JBoss Common Core
# some manual JAR must be creaed and and installed by the maven build
%if %without mead
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation


%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0

find . -name "*.jar" -exec rm -f {} \;
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -DaltDeploymentRepository=jboss-releases::default::file:maven2-brew \
        javadoc:aggregate javadoc:aggregate-jar deploy
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
%if %without mead
install -p -m 644 target/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%else
install -p -m 644 %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
install -p -m 644 %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -sf ${jar} ${jar/-%{namedversion}/}; done)

# pom
install -d -m 755 %{buildroot}%{_mavenpomdir}
%if %without mead
install -p -m 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
install -p -m 644 %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%endif

# depmap
%add_to_maven_depmap org.jboss %{name} %{namedversion} JPP %{name}

%if %without mead
# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
pushd %{buildroot}%{_javadocdir} 
ln -s %{name}-%{namedversion} %{name}
popd
%endif

%if %without mead
# manual
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{namedversion}
cp -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
rm -rf %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %without mead
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 1:2.2.17-10.GA_redhat_2
- Rebuild for MD5

* Mon Aug 20 2012 Honza Brazdil <jbrazdil@redhat.com> - 1:2.2.17-9.GA_redhat_2
- Update pom patch for eap 6.0.1

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 1:2.2.17-8.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 1:2.2.17-8.GA_redhat_1.1
- Rebuild using cache signing

* Tue Jun 19 2012 Martha Benitez <mbenitez@redhat.com> - 1:2.2.17-8.GA_redhat_1
- Install sources.jar

* Tue Jun 19 2012 Martha Benitez <mbenitez@redhat.com> - 1:2.2.17-7.GA_redhat_1
- Build in MEAD

* Wed May 23 2012 Fernando Nasser <fnasser@redhat.com> - 1:2.2.17-6.GA_redhat_1
- Remove javadoc subpackage and javadoc JAR from SRPM if built as a wrapper

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 1:2.2.17-5.GA_redhat_1
- Raise Epoch to ensure we win over the EAP 5 one

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.2.17-4.GA_redhat_1.1
- Rebuild using cache signing

* Mon Feb 13 2012 David Walluck <dwalluck@redhat.com> 0:2.2.17-4
- jakarta-commons-httpclient is marked optional in pom
- main package requires jpackage-utils
- aggregate javadoc

* Fri Feb 03 2012 David Walluck <dwalluck@redhat.com> 0:2.2.17-3
- fix jar location
- fix javadoc location
- remove META-INF from javadoc
- javadoc requires jpackage-utils
- fix repolib file ownership

* Thu Feb 02 2012 Fernando Nasser <fnasser@redhat.com> 0:2.2.17-2_redhat_1.1
- Make webdav optional

* Thu Feb 02 2012 Hui Wang <huwang@redhat.com> 0:2.2.17-2_redhat_1
- Update pom patch 
- Cleanup

* Tue Aug 30 2011 Lin Gao <lgao@redhat.com> 0:2.2.17-1.4
- wolf build

* Wed Aug 10 2011 Lin Gao <lgao@redhat.com> 0:2.2.17-1.3
- Add javadoc in repolib
- toggole mead state
- patch pom to use artifacts versions which are available in mead repository

* Fri Feb 11 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.17-1.2
- Fix repolib contents

* Fri Feb 11 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.17-1.1
- Re-add javadocs

* Fri Feb 11 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.17-1
- Upgrade to 2.2.17.GA for EAP 5.1.1

* Tue Feb 08 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.16-6.2
- Unsign JARs in javadir as they came signed from MEAD

* Wed Jan 19 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.16-6
- Use MEAD-built binaries

* Mon Jan 17 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.2.16-5
- Fix upload.sh

* Thu Nov 25 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.2.16-4
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew
- Add the line to find and remove any binaries
- Disable "site" documentation generation
- comment BR liberation-fonts

* Fri Jul 09 2010 Martha Benitez <mbenitez@redhat.com> 0:2.2.16-3
- Add Obsoletes jboss-common

* Tue Jun 22 2010 David Walluck <dwalluck@redhat.com> 0:2.2.16-2.2.2
- rebuild

* Tue Apr 6 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.2.16-2.1
- Rebuild

* Fri Nov 20 2009 Martha Benitez <mbenitez@redhat.com> 0:2.2.16-2
- Add pom.xml to repolib
- Add patch for pom.xml dependency versions

* Wed Oct 07 2009 Permaine Cheung <pcheung@redhat.com> 0:2.2.16-1
- Upgrade to 2.2.16
- Fix component-info.xml
- jboss-common-core-build.patch no longer needed

* Tue Sep 01 2009 Fernando Nasser <fnasser@redhat.com> 0:2.2.15-2
- Update the component-info
- Generate and install source.jar in repolib

* Tue Sep 01 2009 Fernando Nasser <fnasser@redhat.com> 0:2.2.15-1
- Upgrade to 2.2.15

* Thu Jun 11 2009 Martha Benitez <mbenitez@redhat.com> 0:2.2.14-2.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3
 
* Tue May 26 2009 David Walluck <dwalluck@redhat.com> 0:2.2.14-2
- enable site

* Thu May 21 2009 David Walluck <dwalluck@redhat.com> 0:2.2.14-1
- 2.2.14

* Wed May 20 2009 David Walluck <dwalluck@redhat.com> 0:2.2.13-1
- 2.2.13.GA

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:2.2.11-1
- 2.2.11.GA

* Tue Feb 10 2009 David Walluck <dwalluck@redhat.com> 0:2.2.10-4
- small cleanup

* Tue Feb 10 2009 David Walluck <dwalluck@redhat.com> 0:2.2.10-3
- add Requires for jpackage-utils

* Mon Feb 09 2009 David Walluck <dwalluck@redhat.com> 0:2.2.10-2
- fix repolib location

* Mon Feb 09 2009 David Walluck <dwalluck@redhat.com> 0:2.2.10-1
- 2.2.10.GA
- add repolib

* Fri Feb 06 2009 Ralph Apel <r.apel@r-apel.de> 0:2.2.8-1.jpp5
- First release
